import numpy as np
import cv2 as cv
import glob2
import natsort

# Simple CoM algorithm with noise substraction and both horizontal (to reduce computation)
# and vertical (because of powder deposition) windowing

V = 2592
H = 1944
cropH = 850
cropV = 0
scale = 1.5   #4, 3, 1.5
laserLine = np.zeros(V - 2 * cropV, dtype=float)  # Pixel index of each pixel forming the laser line
lineList = np.zeros(V - 2 * cropV, dtype=float)  # List made of each frame's laser line
R = np.zeros((V - 2 * cropV, H - 2 * cropH))
maxI = np.zeros(V)

def center_of_mass(array):
    p_sum = 0
    weighted_sum = 0
    for count, pixel in enumerate(array):
        if 0 < pixel:
            p_sum += pixel
            weighted_sum += pixel * count
    if p_sum == 0:
        return 0
    else:
        return weighted_sum / p_sum

images = glob2.glob(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\scan*.bmp')
images = natsort.natsorted(images, key=lambda y: y.lower())
count = 0
for fname in images:
    img = cv.imread(fname)      # Image of dimension (1944, 2592, 3), with 3 being the BGR values

    for i in range(len(R)):
        R[i] = img[cropH:H-cropH, i + cropV, 2]

    for i in range(len(R)):
        thr = max(R[i]) / scale
        maxI[i] = max(R[i])
        for j in range(len(R[0])):
            if R[i, j] < thr:
                R[i, j] = 0
        laserLine[i] = center_of_mass(R[i, :]) + cropH

    f1 = open(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\line%d.txt' % count, "w+")
    # Saving the array in a text file
    np.savetxt(f1, laserLine)
    f1.close()
    count += 1

           cmap='viridis', edgecolor='none')
#ax.set_title('surface')
ax.view_init(0, 90)
ax.set_xlabel('x(mm)')
ax.set_ylabel('y(mm)')
ax.set_zlabel('z(µm)')
plt.show()

df_cm = pd.DataFrame(heightMap, index = y,
                  columns = x)
ax = sb.heatmap(df_cm, annot=False, xticklabels=5, yticklabels=20, cbar_kws={'label': 'z (µm)'})
plt.