import numpy as np
import cv2 as cv
import glob2
import natsort
import time

# Simple CoM algorithm with noise substraction and both horizontal (to reduce computation)
# and vertical (because of powder deposition) windowing

V = 2592
H = 1944
cropH = 850
cropV = 0
order = 24
laserLine = np.zeros(V - 2 * cropV, dtype=float)  # Pixel index of each pixel forming the laser line
flaserLine = np.zeros(V - 2 * cropV, dtype=float)
R = np.zeros((V - 2 * cropV, H - 2 * cropH))
fR = np.zeros((V - 2 * cropV, H - 2 * cropH - order+1))
dR = np.zeros((V - 2 * cropV, H - 2 * cropH - 2 * order))
fs = np.ones(order)
ds = np.zeros(order)
ds = np.insert(ds, 0, 1)
ds = np.append(ds, -1)

images = glob2.glob(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\scan*.bmp')
images = natsort.natsorted(images, key=lambda y: y.lower())
count = 0
f2 = open(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\Ftiming%d.txt' % order, "w+")
for fname in images:
    img = cv.imread(fname)      # Image of dimension (1944, 2592, 3), with 3 being the BGR values

    for i in range(len(R)):
        R[i] = img[cropH:H-cropH, i + cropV, 2]

    start = time.time()
    for i in range(len(fR)):
        fR[i] = np.convolve(R[i], fs, 'valid')

    for i in range(len(dR)):
        dR[i] = np.convolve(fR[i], ds, 'valid')
        pos = dR[i] >= 0
        zero_crossing = (pos[:-1] & ~pos[1:]).nonzero()[0]
        pixel = zero_crossing[np.argmax(fR[i, zero_crossing + order])]

        delta = dR[i, pixel] / (dR[i, pixel] - dR[i, pixel + 1])
        flaserLine[i] = pixel + order + delta + cropH

    shifted_dR = np.roll(dR, int(order/2)+1, axis=1)

    end = time.time()
    print("Elapsed time is: ", end-start)
    f1 = open(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\Fline%d.txt' % count, "w+")
    # # Saving the array in a text file
    np.savetxt(f1, flaserLine)
    f1.close()
    f2.write(str(end - start) + '\n')
    count += 1
f2.close() as np
import cv2 as cv
import glob2
import natsort
import time

# Simple CoM algorithm with noise substraction and both horizontal (to reduce computation)
# and vertical (because of powder deposition) windowing

V = 2592
H = 1944
cropH = 850
cropV = 0
order = 24
laserLine = np.zeros(V - 2 * cropV, dtype=float)  # Pixel index of each pixel forming the laser line
flaserLine = np.zeros(V - 2 * cropV, dtype=float)
R = np.zeros((V - 2 * cropV, H - 2 * cropH))
fR = np.zeros((V - 2 * cropV, H - 2 * cropH - order+1))
dR = np.zeros((V - 2 * cropV, H - 2 * cropH - 2 * order))
fs = np.ones(order)
ds = np.zeros(order)
ds = np.insert(ds, 0, 1)
ds = np.append(ds, -1)

images = glob2.glob(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\scan*.bmp')
images = natsort.natsorted(images, key=lambda y: y.lower())
count = 0
f2 = open(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\Ftiming%d.txt' % order, "w+")
for fname in images:
    img = cv.imread(fname)      # Image of dimension (1944, 2592, 3), with 3 being the BGR values

    for i in range(len(R)):
        R[i] = img[cropH:H-cropH, i + cropV, 2]

    start = time.time()
    for i in range(len(fR)):
        fR[i] = np.convolve(R[i], fs, 'valid')

    for i in range(len(dR)):
        dR[i] = np.convolve(fR[i], ds, 'valid')
        pos = dR[i] >= 0
        zero_crossing = (pos[:-1] & ~pos[1:]).nonzero()[0]
        pixel = zero_crossing[np.argmax(fR[i, zero_crossing + order])]

        delta = dR[i, pixel] / (dR[i, pixel] - dR[i, pixel + 1])
        flaserLine[i] = pixel + order + delta + cropH

    shifted_dR = np.roll(dR, int(order/2)+1, axis=1)

    end = time.time()
    print("Elapsed time is: ", end-start)
    f1 = open(r'C:\Users\Max\Documents\Ulg\TFE\TFE\Mesures\2D\still\recap\repetability\1\Fline%d.txt' % count, "w+")
    # # Saving the array in a text file
    np.savetxt(f1, flaserLine)
    f1.close()
    f2.write(str(end - start) + '\n')
    count += 1